/*
 * Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
 *
 * SPDX-License-Identifier: MPL-2.0
 */

@import '../../../style/plateg-cockpit-variables.less';

.wide-visible() {
  @media screen and (max-width: 783px) {
    display: none;
  }
}

.narrow-visible() {
  display: none;
  @media screen and (max-width: 783px) {
    display: block;
  }
}

.circle-button-basics() {
  width: 36px;
  height: 36px;
  margin-left: 5px;
  margin-right: 5px;
  &:hover,
  &:focus {
    color: white;
    background-color: @cockpit-blue;
  }
  &:focus {
    outline-color: white;
  }
}

.header-text-button() {
  .wide-visible;
  color: white;
  margin-right: 10px;
  .button-effects;
  &:hover,
  &:focus {
    color: white !important;
  }
}

.button-effects() {
  border: none;
  box-shadow: none;
  &:hover,
  &:focus {
    background-color: white;
    color: @cockpit-blue !important;
    border: none;
    box-shadow: none;
  }
  &:focus {
    outline: 1px dotted white !important;
    color: @cockpit-blue !important;
  }
  &:active {
    background-color: @cockpit-blue;
    color: white;
  }
}

/* Header */
.ant-layout-header {
  .additional-buttons {
    float: right;
    margin: 0;
    padding-left: 5px;
    padding-right: 8px;
    button + button {
      margin: 15px;
    }
    button {
      .header-text-button;
      position: relative;
      .ant-image > .search-app-icon {
        padding-right: 8px;
        padding-bottom: 2px;
      }
      &:focus {
        .ant-image > .search-app-icon {
          filter: invert(1);
        }
      }
      &:hover,
      &.active {
        background: none;
        color: #fff !important;
        &:after {
          content: '';
          position: absolute;
          width: 64%;
          height: 2px;
          bottom: -7px;
          background-color: #fff;
          left: 18%;
        }
        &:focus {
          background-color: white;
          color: @cockpit-blue;
        }
        &.search-app-btn {
          &:after {
            content: '';
            position: absolute;
            width: 73%;
            height: 2px;
            bottom: -2px;
            background-color: #fff;
            left: 18%;
          }
        }
      }
    }
  }
  .piktogramm-buttons {
    .wide-visible;
    a {
      .button-effects;
      position: relative;
      &:hover,
      &.active {
        background: none;
        color: #fff;
        &:after {
          content: '';
          position: absolute;
          width: 64%;
          height: 2px;
          bottom: -7px;
          background-color: #fff;
          left: 18%;
        }
        &:focus {
          background-color: white;
          color: @cockpit-blue;
        }
      }
    }
  }
  .additional-buttons,
  .piktogramm-buttons {
    white-space: nowrap;
  }
  .vertical-bar {
    border-right: 1px solid @cockpit-header-gray;
    height: 50%;
    .wide-visible;
  }
  .user-menu-container,
  .logout-timer-menu {
    border: 1px solid #fff;
    background-color: #fff;
    padding: 12px;
    padding-top: 8px;
    padding-bottom: 4px;
    position: fixed;
    top: @cockpit-header-height;
    box-shadow: 0 2px 8px #00000026;
    .upper-section {
      margin: 2px;
      margin-left: 0;
      background-color: white;
      color: black;
      font-size: 1.4rem;
      display: flex;
      @media screen and (max-width: 783px) {
        display: none;
      }
      .avatar-container {
        flex: 0 0 33%;
        max-width: 33%;
        text-align: center;

        .ant-avatar {
          top: 50%;
          transform: translateY(-50%);
          background-color: black;
          border: 1px solid black;
        }
      }
      .name-div {
        line-height: 26px;
        margin-top: 15px;
        margin-bottom: 15px;
        min-width: 220px;
        .full-name {
          font-weight: 600;
          line-height: 26px;
          margin-bottom: 0;
          padding-left: 5px;
        }
        .settings-link {
          padding: 5px;
        }
      }
    }
    .user-menu {
      border: none;
      padding: 5px;
      padding-left: 0;
      padding-right: 0;
      .subsection-heading {
        line-height: 26px;
        margin-bottom: 0;
        font-size: 1.3rem;
        padding-left: 10px;
        text-transform: uppercase;
      }
      .ant-menu-item {
        line-height: 22px;
        height: fit-content;
        padding: 8px 12px;
        margin: 0 !important;
        a,
        button {
          font-size: 1.4rem;
          font-weight: 600;
          text-decoration: none;
          &:hover,
          &:focus {
            color: white;
            background-color: black;
          }
        }
        &.ant-menu-item-only-child {
          &:hover {
            border: none;
            box-shadow: none;
          }
          &.ant-menu-item-active {
            border: none;
            box-shadow: none;
          }
        }
      }
      @media screen and (max-width: 783px) {
        top: @cockpit-header-height;
        right: 0;
        position: fixed;
        //height: calc(100vh - @cockpit-header-height);
        // width: 100vw;
        a {
          margin-left: 12px;
        }
        .subsection-heading {
          padding-left: 23px;
        }
      }
    }
  }
  &.cockpit-header-standard {
    background: @cockpit-header-background;
    color: white;
    .cockpit-header;
    scrollbar-width: thin;
    &::-webkit-scrollbar {
      height: 5px;
    }
    &::-webkit-scrollbar-track {
      background: #ddd;
    }
    &::-webkit-scrollbar-thumb {
      background: #666;
    }
  }
  &.cockpit-header-stellvertretung {
    background: @header-orange;
    color: black;
    top: 0;
    .cockpit-header(#000, #000);
    .cockpit-header-logo {
      svg {
        color: black;
      }
      &:hover {
        span.title {
          &:after {
            background-color: black;
          }
        }
      }
      &:focus {
        background-color: @cockpit-blue;
        outline: 1px dotted black !important;
        svg {
          color: white;
        }
        span.title {
          color: white;
        }
      }
    }
    .additional-buttons {
      button {
        color: black;
        &:hover,
        &.active {
          background: none;
          color: black;
          &:after {
            background-color: black;
          }
          &:focus {
            background-color: #fff;
            color: @cockpit-blue;
          }
        }
      }
      &.stellvertretung-title {
        font-size: 1.4rem;
        svg {
          vertical-align: middle;
          margin: -2px 5px 0 10px;
          font-size: 1.8rem;
          circle {
            fill: #000;
          }
        }
      }
    }
    .logout-timer-button {
      color: black;
      &:focus,
      &:hover {
        color: black !important;
        outline-color: black !important;
      }
    }
    .vertical-bar {
      border-right: 1px solid #fff;
    }
    .initials-button {
      color: white;
      background-color: black;
    }
    #head-neuigkeiten-drawer-btn {
      path:nth-child(2) {
        fill: black;
      }
      &:focus,
      &:hover {
        outline-color: black !important;
        path:nth-child(2) {
          fill: none;
        }
        path:nth-child(3) {
          fill: black;
        }
      }
    }
  }
}

// fixes nexted position-fixed elements with overflow style on parent
.overflow-class {
  position: fixed;
  width: 100%;
  z-index: 1063;
}
.cockpit-header(@textColor: #fff,  @headerLogoColor: #fff) {
  overflow-x: auto;
  overflow-y: hidden;
  display: flex;
  flex-direction: row;
  line-height: 64px;
  height: @cockpit-header-height;
  padding: @cockpit-header-padding;

  .initials-button {
    border: none;
    color: black;
    background-color: white;
    .circle-button-basics;
    margin-right: 5px;
    margin-left: 20px;
    &:hover {
      background-color: @cockpit-blue !important;
    }
  }

  .initials-button-active {
    color: white;
    background-color: @cockpit-blue;
    .circle-button-basics;
    margin-right: 5px;
    margin-left: 20px;
    &:hover {
      background-color: @cockpit-blue !important;
    }
  }

  .iam-btns {
    white-space: nowrap;
  }

  .user-button {
    .circle-button-basics;
    margin-right: 50px;
    .narrow-visible;
    border: none;
  }

  .user-button-active {
    .circle-button-basics;
    margin-right: 50px;
    .narrow-visible;
    border: none;
    background-color: @cockpit-blue;
  }

  .login-div {
    padding-right: 15px;
    margin-left: auto;
    float: right;
    display: flex;
    justify-content: center;
    align-items: center;
    .login-button {
      .wide-visible;
      background-color: @cockpit-blue;
      color: white;
      margin-right: 25px;
      margin-left: 20px;
      .button-effects;
    }
    .register-button {
      .wide-visible;
      height: 32px;
      color: white;
      margin-right: 10px;
      .header-text-button;
      &:hover {
        outline: 1px solid white !important;
      }
    }
  }
  .loggedout-menu {
    top: @cockpit-header-height;
    left: 0;
    position: fixed;
    border-top: 1px solid white;
    border-right: none;
    height: 95vh;
    width: 100vw;
    background-color: black;
    button.login-button {
      display: block;
      margin: 20px auto;
      width: 80vw;
      .button-effects;
    }
    button.register-button {
      display: block;
      margin-left: 10%;
      font-weight: normal;
      .button-effects;
    }
  }
  .cockpit-header-logo {
    max-height: @header-logo-height;
    width: auto;
    display: flex;
    align-items: center;
    justify-content: center;
    flex-direction: row;
    color: #b3b3bf;
    padding-right: 10px;
    text-decoration: none;
    margin: 12px 0 12px 14px;
    border-radius: 8px;

    svg {
      color: white;
      margin: 0 24px 0 10px;
      fill: @headerLogoColor;
    }
    span.title {
      position: relative;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      font-weight: 500;
      color: @textColor;
      margin-left: 10px;
      .light-title {
        font-weight: normal;
      }
      span.title-addition {
        font-weight: 400;
      }
    }
    &:hover {
      background-color: transparent;
      span.title {
        &:after {
          content: '';
          position: absolute;
          width: 100%;
          height: 2px;
          bottom: 15px;
          background-color: #fff;
          left: 0;
        }
      }
    }
    &:focus {
      background-color: white;
      outline: 1px dotted white !important;
      svg {
        color: black;
      }
      span.title {
        color: black;
      }
    }
  }
}

.ant-menu-item.stellvertreter-menu-item {
  display: block;
  line-height: 22px;
  min-height: 32px;
  height: auto !important;
  margin: 10px !important;
  padding: 0 !important;
  width: 310px !important;
  &:hover {
    background-color: @platform-blue4 !important;
  }
  &:focus-visible {
    outline-style: dotted !important;
    outline-color: #000 !important;
    outline-width: 1px !important;
    outline-offset: 2px !important;
    background-color: @platform-blue4;
    text-decoration: underline;
    border-radius: 3px;
  }
  & > span {
    display: block;
    min-width: 100%;
    & > button {
      padding: 5px 12px !important;
      min-width: 100%;
      text-align: left;
      display: block;
      &:focus-visible {
        outline: 0.1rem dotted black !important;
        outline-offset: 2px !important;
        background-color: @platform-blue4;
        text-decoration: underline;
        border-radius: 3px;
      }
      .icon-holder {
        display: inline;
        position: relative;
        padding-right: 30px;
      }
    }
  }
  &.ant-menu-item-active,
  &.ant-menu-item-selected {
    border: 0;
    background-color: @platform-blue4;
    * {
      color: black;
    }
    &:hover * {
      text-decoration: underline;
      color: black;
      background-color: @platform-blue4 !important;
    }
  }
  a,
  button {
    font-size: 1.4rem;
    font-weight: 600;
    text-decoration: none;
    padding-right: 30px;
    position: relative;
    white-space: normal;
    .icon {
      position: absolute;
      right: 2px;
      svg {
        fill: @blue-5;
      }
    }
    &:hover,
    &:focus {
      background-color: transparent;
    }
  }
}
.stellvertreter-menu-divider {
  width: 90%;
  background-color: #ddd;
}

#menu-item-bar-collapse-btn {
  height: 64px;
  width: 64px;
  background-color: #0032d9;
  border-style: dotted;
  & svg {
    width: 24px;
    height: 24px;
    transition: inherit;
  }
  &:focus {
    height: 62px;
    outline: 1px solid black !important;
    outline-offset: -2px !important;
    border: 1px dotted #fff !important;
    & svg {
      margin-top: 2px;
    }
  }
  &:hover {
    height: 62px;
    border: 2px solid black !important;
    & svg {
      margin-top: 2px;
    }
  }
}
